// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
	cloud "github.com/hashicorp/hcp-sdk-go/clients/cloud-shared/v1/models"
)

// HashicorpCloudConsul20210204Snapshot Snapshot is our representation needed to back-up a cluster.
//
// swagger:model hashicorp.cloud.consul_20210204.Snapshot
type HashicorpCloudConsul20210204Snapshot struct {

	// created_at is the time that this snapshot was requested.
	// Format: date-time
	CreatedAt strfmt.DateTime `json:"created_at,omitempty"`

	// finished_at is the time that this snapshot was finished.
	// Format: date-time
	FinishedAt strfmt.DateTime `json:"finished_at,omitempty"`

	// id is the snapshot’s ID.
	ID string `json:"id,omitempty"`

	// location is the snapshot’s location.
	Location *cloud.HashicorpCloudLocationLocation `json:"location,omitempty"`

	// meta is the snapshot metadata.
	Meta *HashicorpCloudConsul20210204SnapshotSnapshotMeta `json:"meta,omitempty"`

	// name is the name of the snapshot.
	Name string `json:"name,omitempty"`

	// resource is the resource the snapshot was taken from.
	Resource *cloud.HashicorpCloudLocationLink `json:"resource,omitempty"`

	// running_operation_id is the ID of an operation performing work related to the current state of the snapshot.
	RunningOperationID string `json:"running_operation_id,omitempty"`

	// self_link is a link referring to this snapshot.
	SelfLink *cloud.HashicorpCloudLocationLink `json:"self_link,omitempty"`

	// state represents the current status for this snapshot.
	State HashicorpCloudConsul20210204SnapshotSnapshotState `json:"state,omitempty"`

	// type represents the type of this snapshot.
	Type HashicorpCloudConsul20210204SnapshotSnapshotType `json:"type,omitempty"`
}

// Validate validates this hashicorp cloud consul 20210204 snapshot
func (m *HashicorpCloudConsul20210204Snapshot) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateCreatedAt(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateFinishedAt(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLocation(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateMeta(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateResource(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSelfLink(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateState(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateType(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *HashicorpCloudConsul20210204Snapshot) validateCreatedAt(formats strfmt.Registry) error {

	if swag.IsZero(m.CreatedAt) { // not required
		return nil
	}

	if err := validate.FormatOf("created_at", "body", "date-time", m.CreatedAt.String(), formats); err != nil {
		return err
	}

	return nil
}

func (m *HashicorpCloudConsul20210204Snapshot) validateFinishedAt(formats strfmt.Registry) error {

	if swag.IsZero(m.FinishedAt) { // not required
		return nil
	}

	if err := validate.FormatOf("finished_at", "body", "date-time", m.FinishedAt.String(), formats); err != nil {
		return err
	}

	return nil
}

func (m *HashicorpCloudConsul20210204Snapshot) validateLocation(formats strfmt.Registry) error {

	if swag.IsZero(m.Location) { // not required
		return nil
	}

	if m.Location != nil {
		if err := m.Location.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("location")
			}
			return err
		}
	}

	return nil
}

func (m *HashicorpCloudConsul20210204Snapshot) validateMeta(formats strfmt.Registry) error {

	if swag.IsZero(m.Meta) { // not required
		return nil
	}

	if m.Meta != nil {
		if err := m.Meta.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("meta")
			}
			return err
		}
	}

	return nil
}

func (m *HashicorpCloudConsul20210204Snapshot) validateResource(formats strfmt.Registry) error {

	if swag.IsZero(m.Resource) { // not required
		return nil
	}

	if m.Resource != nil {
		if err := m.Resource.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("resource")
			}
			return err
		}
	}

	return nil
}

func (m *HashicorpCloudConsul20210204Snapshot) validateSelfLink(formats strfmt.Registry) error {

	if swag.IsZero(m.SelfLink) { // not required
		return nil
	}

	if m.SelfLink != nil {
		if err := m.SelfLink.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("self_link")
			}
			return err
		}
	}

	return nil
}

func (m *HashicorpCloudConsul20210204Snapshot) validateState(formats strfmt.Registry) error {

	if swag.IsZero(m.State) { // not required
		return nil
	}

	if err := m.State.Validate(formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("state")
		}
		return err
	}

	return nil
}

func (m *HashicorpCloudConsul20210204Snapshot) validateType(formats strfmt.Registry) error {

	if swag.IsZero(m.Type) { // not required
		return nil
	}

	if err := m.Type.Validate(formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("type")
		}
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *HashicorpCloudConsul20210204Snapshot) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *HashicorpCloudConsul20210204Snapshot) UnmarshalBinary(b []byte) error {
	var res HashicorpCloudConsul20210204Snapshot
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
